' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - LCARS Nav for Next ------------------------------------
' ---------------------------------------------------------
    

' - Print combat menu -------------------------------------
SUB LCARS_Combat_DrawMenu()
    DIM n, maxN AS UByte
    
    BankSwitch67(BANK_LCARS_FONT)
    LCARS_SelectMenu(OPT_RED)
    
    'maxN = LCARS_Y2 - 9
    'FOR n = 105 TO maxN STEP 8
    '    PrintFont88(0,n,"cccc  ",Opt_Colours(OPT_RED),0)
    'NEXT n
    
    'LCARS_Combat_DrawMenuOpt(0,33,"PHASER",0,Opt_Colours(OPT_TACTIC),"P")
    'LCARS_Combat_DrawMenuOpt(0,42,"TORPED",0,Opt_Colours(OPT_CTRL),"T")
    'LCARS_Combat_DrawMenuOpt(0,51,"EVADE",0,Opt_Colours(OPT_NAV),"E")
    'LCARS_Combat_DrawMenuOpt(0,60,"IMPULS",0,Opt_Colours(OPT_MAP),"I")
    'LCARS_Combat_DrawMenuOpt(0,69,"WARP",0,Opt_Colours(OPT_STATUS),"W")
    'LCARS_Combat_DrawMenuOpt(0,78,"TRACTR",0,Opt_Colours(OPT_OPS),"R")
    'LCARS_Combat_DrawMenuOpt(0,87,"SHLDWN",0,Opt_Colours(OPT_DAMAGE),"S")
    'LCARS_Combat_DrawMenuOpt(0,96,"HELP",0,Opt_Colours(OPT_HELP),"H")
    
    BankSwitch67(BANK_TACTIC_ENTERPRISE)
    PrintSprite(0,140,56)
    PrintSprite(16,140,57)
    PrintSprite(0,156,60)
    PrintSprite(16,156,61)
END SUB


' - Draw menu option --------------------------------------
SUB LCARS_Combat_DrawMenuOpt(x AS UByte, y AS UByte, text AS String, c1 AS UByte, c2 AS UByte, k AS String)
    PrintFont88(x,y,"    ",c1,c2)
    PrintFont48(x+1,y,text,c1,c2)
    PrintFont88(x+32,y,"o",c2,c1)
    PrintFont48(34,y,k,0,227)
END SUB


' - Draws the sector grid ---------------------------------
SUB LCARS_Nav_DrawGrid()
    DIM xs, ys, xss, yss, xg, yg, maxX, maxY AS Integer
    DIM obj, id AS UByte
    DIM Ent_X, Ent_Y AS Integer
    
    Ent_X = Status_Position_Sector_X
    
    Ent_Y = Status_Position_Sector_Y
    xss = LCARS_XM - 24 - (Ent_X * 16) + (Ent_Y * 16)
    yss = LCARS_YM - 16 - (Ent_X * 8) - (Ent_Y * 8)

    maxX = LCARS_X2 - 20
    maxY = LCARS_Y2 - 16

    LCARS_ClearFast(227)    
        
    FOR xs = 0 TO MAP_SECTOR_MAXX
        FOR ys = 0 TO MAP_SECTOR_MAXY
            ' Calculate grid coords on screen            
            xg = xss + (xs * 16) - (ys * 16)
            yg = yss + (xs * 8) + (ys * 8)

            ' Avoid draw if out of screen
            IF xg < LCARS_X1 OR xg > maxX THEN
                CONTINUE FOR
            END IF
            IF yg < LCARS_Y1 OR yg > maxY THEN
                CONTINUE FOR
            END IF
            
            ' Get object
            BankSwitch67(BANK_SECTOR_MAP)
            obj = Map_Sector(xs,ys)
            
            ' Draw back grid
            BankSwitch67(BANK_TACTIC_ENTERPRISE)
            PrintSprite(xg,yg,44)
            PrintSprite(xg+16,yg,45)
            
            IF xs = Ent_X THEN
                IF ys = Ent_Y THEN
                     BankSwitch67(BANK_COMBAT_SHIPS)
                     id = Ent_Dir * 4
                     PutSprite4(xg,yg-12,id)                    
                END IF
            END IF
             
            IF obj = 0 THEN
                CONTINUE FOR
            ELSEIF obj < MAP_OBJECT_STARBASE THEN
                id = (obj * 16) + 8   ' TODO: direction
                BankSwitch67(BANK_COMBAT_SHIPS)  
                PutSprite4(xg,yg-12,id)   
            ELSEIF obj >= MAP_OBJECT_STARBASE THEN
                BankSwitch67(BANK_LCARS_GRID)
                id = (obj - MAP_OBJECT_STARBASE) * 4
                PutSprite4(xg,yg-6,id)
            END IF
            
            BankSwitch67(BANK_TACTIC_ENTERPRISE)
            PrintSprite(xg,yg,46)
            PrintSprite(xg+16,yg,47)
        NEXT ys
    NEXT xs    
    
    LCARS_Nav_DrawScanner()
    LCARS_Nav_DrawEnterprise()
    IF Status_Condition = 2 THEN
        LCARS_Nav_DrawEnemy()
        LCARS_Nav_DrawCombatLog()
    ELSE
        LCARS_Nav_DrawSectorInfo()
    END IF
    
    BankSwitch67(BANK_LCARS_FONT)
END SUB


' - Draw Scanner ----------------------------------------------
SUB LCARS_Nav_DrawScanner()
    DIM x, y, xs, ys, obj, c, maxY AS Byte
    
    BankSwitch67(BANK_LCARS_FONT)
    PrintFont88(LCARS_X1,LCARS_Y1,"e    ",151,0)
    PrintFont88(LCARS_X1 + 34,LCARS_Y1,"c",151,0)
    PrintFont48(LCARS_X1 + 38,LCARS_Y1," ",151,0)
    PrintFont48(LCARS_X1 + 9,LCARS_Y1,str(Status_Position_Sector_X) + "," + str(Status_Position_Sector_Y),151,0)
    maxY = LCARS_Y1 + 39
    FOR y = LCARS_Y1 + 8 TO maxY STEP 8
        PrintFont88(LCARS_X1,y, "c    ",151,0)
    NEXT y
    
    BankSwitch67(BANK_TACTIC_ENTERPRISE)
    PutSprite4(LCARS_X1+6,LCARS_Y1+8,40)

    BankSwitch67(BANK_SECTOR_MAP)
    FOR ys = 0 TO MAP_SECTOR_MAXX
        FOR xs = 0 TO MAP_SECTOR_MAXX
            obj = Map_Sector(xs,ys)
            IF obj > 0 THEN
                c = 255
                IF obj < MAP_OBJECT_STARBASE THEN
                    ' Enemies
                    c = 224
                ELSE IF obj = MAP_OBJECT_STARBASE THEN
                    ' StarBase
                    c = 2
                ELSE IF obj < MAP_OBJECT_PLANET_0 THEN
                    ' Stars
                    c = 216
                ELSE IF obj < MAP_OBJECT_PLANET_M THEN
                    ' Planets
                    c = 100
                ELSE IF obj = MAP_OBJECT_PLANET_M THEN
                    ' Planets class M
                    c = 16
                ELSEIF obj = MAP_OBJECT_PLANET_DILITRIUM THEN
                    ' Planets with dilitrium
                    c = 226
                END IF   
                
                x = xs/2
                y = ys/2
                                
                PlotL2(LCARS_X1 + x + 7,LCARS_Y1 + y + 9,c)
            END IF
        NEXT xs
    NEXT ys
        
    ' Enemies
    BankSwitch67(BANK_TACTIC_ENTERPRISE)
    FOR n = 0 TO ENEMIES_SECTOR_MAX
        IF Enemies_Sector(n,ENEMIES_SECTOR_TYPE) <> 0 THEN
            x = Enemies_Sector(n,ENEMIES_SECTOR_X) / 2
            y = Enemies_Sector(n,ENEMIES_SECTOR_Y) / 2
            PrintSprite(LCARS_X1 + x + 6,LCARS_Y1 + y + 8,48)           
        END IF
    NEXT n
    
    ' Enterprise
    x = Status_Position_Sector_X/2
    y = Status_Position_Sector_Y/2
    PrintSprite(LCARS_X1 + x + 6,LCARS_Y1 + y + 8,39)
END SUB


' - Draw sector info --------------------------------------
SUB LCARS_Nav_DrawSectorInfo()
    DIM x, y, yy AS UByte
    
    x = LCARS_X2 - 96
    y = LCARS_Y2 - 39
    BankSwitch67(BANK_LCARS_FONT)
    PrintFont88(x,y,"ec       ccc",208,0)
    PrintFont48(x+11,y," ",208,0)
    PrintFont48(x+12,y,"SECTOR " + str(Status_Position_Galaxy_X+1) + "," + str(Status_Position_Galaxy_Y+1),208,0)
    'PrintFont88(LCARS_X2-8,LCARS_Y2-40,"c",208,0)
    FOR yy = y + 8 TO LCARS_Y2 STEP 8
        PrintFont88(x,yy,"c           ",208,0)
    NEXT yy
    
    x = x + 10
    PrintFont48(x,y+8 ,"ENEMIES    :"+str(Sector_Enemies),224,0)
    PrintFont48(x,y+16,"STARBASES  :"+str(Sector_StarBases),15,0)
    PrintFont48(x,y+24,"STARS      :"+str(Sector_Stars),216,0)
    PrintFont48(x,y+32,"PLANETS    :"+str(Sector_Planets),100,0)
    PrintFont48(x+40,y+32,"M",16,0)
    PrintFont48(x+50,y+32,"D",226,0)
    PrintFont48(x+70,y+32,str(Sector_Planets_M),16,0)
    PrintFont48(x+80,y+32,str(Sector_Planets_Dilitrium),226,0)
END SUB


' - Draw sector info --------------------------------------
SUB LCARS_Nav_DrawCombatLog()
    DIM x, y, yy AS UByte
    
    x = LCARS_X2 - 119
    y = LCARS_Y2 - 39
    BankSwitch67(BANK_LCARS_FONT)
    PrintFont88(x,y,"ec      ccccccc",224,0)
    PrintFont48(x+11,y," ",224,0)
    PrintFont48(x+12,y,"COMBAT LOG ",224,0)
    FOR yy = y + 8 TO LCARS_Y2 STEP 8
        PrintFont88(x,yy,"c              ",224,0)        
    NEXT yy
    
    x = x + 10
    'PrintFont48(x,y+8 ,"012345678901234567890",224,0)
    y = y + 8
    'PrintFont48(x,y+8 ,"012345678901234567890",224,0)
    y = y + 8
    'PrintFont48(x,y+8 ,"012345678901234567890",224,0)
    y = y + 8
    'PrintFont48(x,y+8 ,"012345678901234567890",224,0)
END SUB


' - Draw tactic info for Enterprise -----------------------
SUB LCARS_Nav_DrawEnterprise()
    DIM n, x, y, id, maxX, c AS UByte
    
    BankSwitch67(BANK_TACTIC_ENTERPRISE)
        
    ' Draw Enterprise
    id = 0
    IF Status_Condition = 2 THEN
        ' Enterprise sprite based on shield
        IF Status_ShieldLevel > 80 THEN
            id = 14
        ELSEIF Status_ShieldLevel > 60 THEN
            id = 12
        ELSEIF Status_ShieldLevel >= 20 THEN
            id = 2
        END IF        
    END IF    
    
    ' Enterprise
    maxX = LCARS_X1 + 31
    FOR y = LCARS_Y2-43 TO  LCARS_Y2 STEP 16
        FOR x = LCARS_X1 TO maxX STEP 16
            PrintSprite(x,y,id)
            id = id + 1
        NEXT x
        id = id + 2
    NEXT y    
    
    ' Standar Gauges
    x = LCARS_X1 + 32
    FOR n = 24 TO 26
        PrintSprite(x,LCARS_Y2 - 16,n)
        x = x + 16
    NEXT n       
    PrintBar(LCARS_X1 + 49,LCARS_Y2 - 15,Status_Damage,100,1)
    PrintBar(LCARS_X1 + 49,LCARS_Y2 - 7,Status_Energy,5000,0)
    
    ' Combat gauges
    IF Status_Condition = 2 THEN
        x = LCARS_X1 + 32
        FOR n = 28 TO 30
            PrintSprite(x,LCARS_Y2 - 32,n)
            x = x + 16
        NEXT n       
        PrintBar(LCARS_X1 + 49,LCARS_Y2 - 31,Status_ShieldLevel,100,0)
        PrintBar(LCARS_X1 + 49,LCARS_Y2 - 23,Status_PhasersLevel,100,0)
        
        BankSwitch67(BANK_LCARS_FONT)
        IF Status_TorpedoesColdDown = 0 THEN
            c = 16
        ELSE
            c = 224
        END IF
        PrintFont48(LCARS_X1 + 32,LCARS_Y2 - 41,"TORP:"+str(Status_Torpedoes),c,0)
    END IF
END SUB


' - Draw enemy Ship ---------------------------------------
SUB LCARS_Nav_DrawEnemy()
    DIM n, t, sh, id, x, y, maxX, maxY, idn AS UByte
    
    ' Ship
    BankSwitch67(BANK_TACTIC_ENEMY)
    FOR n = 0 TO ENEMIES_SECTOR_MAX
        t = Enemies_Sector(n,ENEMIES_SECTOR_TYPE)
        IF t <> 0 THEN
            idn = n
            sh = Enemies_Sector(n,ENEMIES_SECTOR_SHIELD)
            id = 0
            IF sh > 80 THEN
                id = 14
            ELSEIF sh > 60 THEN
                id = 12
            ELSEIF Status_ShieldLevel >= 20 THEN
                id = 2
            END IF    
            
            maxX = LCARS_X2 - 3
            maxY = LCARS_Y1 + 44
            FOR y = LCARS_Y1 TO maxY STEP 16
                FOR x = LCARS_X2 - 32 TO maxX STEP 16
                    PrintSprite(x,y,id)
                    id = id + 1
                NEXT x
                id = id + 2
            NEXT y 
            EXIT FOR
        END IF
    NEXT n
    
    ' Gauges
    IF id > 0 THEN
        BankSwitch67(BANK_TACTIC_ENTERPRISE)
        x = LCARS_X2 - 81
        FOR n = 36 to 38
            PrintSprite(x,LCARS_Y1 + 8,n)
            x = x + 16
        NEXT n
        PrintBar(LCARS_X2 - 80,LCARS_Y1 + 9,Enemies_Sector(idn,ENEMIES_SECTOR_SHIELD),100,0)
        PrintBar(LCARS_X2 - 80,LCARS_Y1 + 17,Enemies_Sector(idn,ENEMIES_SECTOR_DAMAGE),100,1)
    END IF
END SUB


' - Print percentage bar ----------------------------------
SUB PrintBar(x AS UByte, y AS UByte, value AS UInteger, maxValue AS UInteger, rev AS UByte)
    DIM c, c1, ci, cc1, cc2, cr AS UByte
    DIM xx, yy, xxx, maxX, maxY AS UByte
    DIM per AS Fixed
    
    maxX = x + 29
    maxY = y + 4
    FOR yy = y TO maxY
        FOR xx = x TO maxX
            PlotL2(xx,yy,0)
        NEXT xx
    NEXT yy
    
    IF maxValue = 100 THEN
        per = value
    ELSE
        per = (CAST(Fixed,value) / Cast(Fixed,maxValue)) * 100
    END IF
    
    IF rev = 0 THEN
        IF per > 80 THEN
            c = 16
        ELSEIF per > 20 THEN
            c = %11111100
        ELSE
            c = %11100000
        END IF
    ELSE
        IF per > 80 THEN
            c = %11100000
        ELSEIF per > 20 THEN
            c = %11111100
        ELSE
            c = 16
        END IF
    END IF

    per = per * 0.3
    IF per < 1 THEN
        RETURN
    END IF
    
    maxX = x + per

    FOR yy = y TO maxY
        FOR xx = x TO maxX
            PlotL2(xx,yy,c)
        NEXT xx
    NEXT yy
END SUB