' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - LCARS Status for Next ---------------------------------
' ---------------------------------------------------------

' - Vars --------------------------------------------------
' Colours for energy level indicators
DIM Slider_Colours(2,6) AS UByte = { _
    { %00000100, %00001000, %00001100, %00010000, %00010100, %00011000, %00011100 }, _
    { %00100100, %01001000, %01101100, %10010000, %10110100, %11011000, %11111100 }, _
    { %00100000, %01000000, %01100000, %10000000, %10100000, %11000000, %11100000 } _
}


' - Status ------------------------------------------------
SUB LCARS_Status()
    DIM n, m, x, y AS UByte

    IF Status_Condition = 0 THEN
        PrintText816_RTTY(LCARS_X1,LCARS_Y1,"CONDITION GREEN",16,0)
    ELSEIF Status_Condition = 1 THEN
        PrintText816_RTTY(LCARS_X1,LCARS_Y1,"CONDITION YELLOW",248,0)
    ELSE
        PrintText816_RTTY(LCARS_X1,LCARS_Y1,"CONDITION RED",224,0)
    END IF

    y = LCARS_Y1 + 20
    PrintFont48(LCARS_X1,y,"DAMAGE",16,0)
    GetTotalDamage()
    LCARS_Status_PrintPer(LCARS_X1, y+8,Status_Damage,100,1)
    y = y + 28
    PrintFont48(LCARS_X1,y,"MAIN ENERGY: "+ToString(Status_Energy),16,0)
    LCARS_Status_PrintPer(LCARS_X1, y+8,Status_Energy,ENERGY_MAX,0)
    y = y + 28
    IF Status_Shield = 0 THEN
        PrintFont48(LCARS_X1,y,"SHIELDS - DOWN",212,0)
    ELSE
        PrintFont48(LCARS_X1,y,"SHIELDS - UP",212,0)
    END IF
    LCARS_Status_PrintPer(LCARS_X1, y+8,Status_ShieldLevel,100,0) 
    y = y + 28
    PrintFont48(LCARS_X1,y,"WEAPONS",224,0)
    LCARS_Status_PrintPer(LCARS_X1, y+8, Status_PhasersLevel,100,0)
    y = y + 28
    PrintFont48(LCARS_X1,y,"LIFE SUPPORT",15,0)
    LCARS_Status_PrintPer(LCARS_X1, y+8, Status_LiveSupport,100,0)
END SUB


' - Print percentage bar ----------------------------------
SUB LCARS_Status_PrintPer(x AS UByte, y AS UByte, value AS UInteger, maxValue AS UInteger, rev AS UByte)
    DIM c, c1, ci, cc1, cc2, cr AS UByte
    DIM xx, yy, xxx, maxX, maxY AS UByte
    DIM per AS Fixed
    
    IF maxValue = 100 THEN
        per = value
    ELSE
        per = (CAST(Fixed,value) / Cast(Fixed,maxValue)) * 100
    END IF
        
    IF per > 80 THEN
        IF rev = 0 THEN
            c = Status_Colours(2)
            cr = 0
        ELSE
            c = Status_Colours(0)
            cr = 2
        END IF
    ELSEIF per > 20 THEN
        c = Status_Colours(1)
        cr = 1
    ELSE
        IF rev = 0 THEN
            c = Status_Colours(0)
            cr = 2
        ELSE
            c = Status_Colours(2)
            cr = 0
        END IF        
    END IF
    PrintFont816(x + 168, y,ToString(per)+"%",c,0)
    
    per = per * 1.6
    maxX = per
    
    maxY = y + 14
    IF maxX > 20 THEN
        c1 = maxX - 20
    ELSE
        c1 = 0
    END IF
    cc1 = 2
    cc2 = 0
    
    xxx = x
    FOR xx = 0 TO maxX
        IF xx < c1 THEN
            ci = Slider_Colours(cr,0)
        ELSE
            ci = Slider_Colours(cr,cc1)
            IF cc2 = 3 THEN
                cc1 = cc1 + 1
                cc2 = 0
            ELSE
                cc2 = cc2 + 1
            END IF
        END IF
        FOR yy = y + 1 TO maxY
            PlotL2(xxx,yy,ci)
        NEXT yy
        xxx = xxx + 1
    NEXT xx    
    
    PrintSpriteClour(x-15,y,56,255)
    xx = x
    FOR n=0 TO 8
        PrintSpriteClour(xx,y,57,255)
        xx = xx + 16
    NEXT n
    PrintSpriteClour(x + 144,y,58,255)
END SUB
