' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - LCARS Damage for Next ---------------------------------
' ---------------------------------------------------------


' - Return the Status level from level damage (0-10) ------
FUNCTION LCARS_Damage_GetStatusColour(level AS UByte) AS UByte
    IF level>7 THEN
        RETURN Status_Colours(0)
    ELSEIF level>3 THEN
        RETURN Status_Colours(1)
    ELSE
        RETURN Status_Colours(2)
    END IF
END FUNCTION


' - Draws the damage screen -------------------------------
SUB LCARS_Damage()
    'LoadImage("DATA/DAMAGES.BMP",LCARS_X1,LCARS_Y1,212,120)
    LCARS_ShowImage(LCARS_X1,LCARS_Y1,BANK_BITMAPS1,BITMAP_ADDR_DAMAGE)
    
    PrintFont48(LCARS_X1+24,LCARS_Y1+1,"SENSORS", _
        LCARS_Damage_GetStatusColour(Status_Damage_Sensors),0)
    LCARS_Damage_DrawStatus(Status_Damage_Sensors,LCARS_X1+179,LCARS_Y1+47)
    
    PrintFont48(LCARS_X1+19,LCARS_Y1+9,"COMPUTER", _
        LCARS_Damage_GetStatusColour(Status_Damage_Computer),0)
    LCARS_Damage_DrawStatus(Status_Damage_Computer,LCARS_X1+128,LCARS_Y1+43)
    
    PrintFont48(LCARS_X1,LCARS_Y1+17,"LIFE SUPPORT", _
        LCARS_Damage_GetStatusColour(Status_Damage_Life),0)
    LCARS_Damage_DrawStatus(Status_Damage_Life,LCARS_X1+113,LCARS_Y1+51)
    
    PrintFont48(LCARS_X1,LCARS_Y1+25,"IMPULSE ENG.", _
        LCARS_Damage_GetStatusColour(Status_Damage_Impulse),0)
    LCARS_Damage_DrawStatus(Status_Damage_Impulse,LCARS_X1+94,LCARS_Y1+49)
    
    PrintFont48(LCARS_X1+5,LCARS_Y1+33,"SHUTTLE BAY", _
        LCARS_Damage_GetStatusColour(Status_Damage_Shuttle),0)
    LCARS_Damage_DrawStatus(Status_Damage_Shuttle,LCARS_X1+78,LCARS_Y1+53)        

    PrintFont48(LCARS_X1+156,LCARS_Y1+76,"PHASERS", _
        LCARS_Damage_GetStatusColour(Status_Damage_Phasers),0)
    LCARS_Damage_DrawStatus(Status_Damage_Phasers,LCARS_X1+138,LCARS_Y1+58) 
    
    PrintFont48(LCARS_X1+156,LCARS_Y1+76+8,"TORPEOES", _
        LCARS_Damage_GetStatusColour(Status_Damage_Torpedoes),0)
    LCARS_Damage_DrawStatus(Status_Damage_Torpedoes,LCARS_X1+97,LCARS_Y1+64) 
    
    PrintFont48(LCARS_X1+156,LCARS_Y1+76+16,"COLLECTOR", _
        LCARS_Damage_GetStatusColour(Status_Damage_Collector),0)
    LCARS_Damage_DrawStatus(Status_Damage_Collector,LCARS_X1+87,LCARS_Y1+77) 
    
    PrintFont48(LCARS_X1+156,LCARS_Y1+76+24,"TRANSPORTER", _
        LCARS_Damage_GetStatusColour(Status_Damage_Trasnport),0)
    LCARS_Damage_DrawStatus(Status_Damage_Trasnport,LCARS_X1+67,LCARS_Y1+72) 
    
    PrintFont48(LCARS_X1+156,LCARS_Y1+76+32,"WARP ENGINE", _
        LCARS_Damage_GetStatusColour(Status_Damage_Warp),0)
    LCARS_Damage_DrawStatus(Status_Damage_Warp,LCARS_X1+19,LCARS_Y1+63) 
    
    GetTotalDamage()
    PrintFont48(LCARS_X1,LCARS_Y1+128,"DAMAGE",16,0)
    LCARS_Status_PrintPer(LCARS_X1,LCARS_Y1+128+8,Status_Damage,100,1)
END SUB


SUB LCARS_Damage_DrawStatus(level AS UByte, x AS UByte, y AS UByte)
    DIM c, xx, yy, n AS UByte
    
    c = LCARS_Damage_GetStatusColour(level)
    yy = y
    FOR n = 0 TO 7
        L2_LineH(x,yy,8,c)
        yy = yy + 1
    NEXT n
END SUB