' ---------------------------------------------------------
' - SSTN --------------------------------------------------
' - LCARS Report for Next ---------------------------------
' ---------------------------------------------------------


' - Vars --------------------------------------------------
DIM NPC_Address(4) AS UInteger = { _
    BITMAP_ADDR_PICARD, _
    BITMAP_ADDR_RIKER, _
    BITMAP_ADDR_DATA, _
    BITMAP_ADDR_GEORDI, _
    BITMAP_ADDR_WORF _
}

DIM NPC_Color(4) AS UByte = { _
    192, 128, 213, 55, 48 _
}


' - Status ------------------------------------------------
SUB LCARS_Report_Tip(npc AS UByte, name AS String)   
    DIM n, x, y AS UByte
    DIM t AS String

    LCARS_PushScreen()
    
    x = LCARS_X1 + 2
    y = LCARS_Y2 - 71
    LCARS_Report_DrawBox(npc,name,x,y)
    y = y + 16
    x = x + 60
    FOR n = 0 TO 5
        t = Messages(n)
        IF t = "#" THEN
            EXIT FOR
        END IF
        PrintFont48(x,y,Messages(n),212,0)
        y = y + 10
    NEXT n
    WaitKey()
    
    LCARS_PopScreen()
END SUB


' - Draw box ----------------------------------------------
SUB LCARS_Report_DrawBox(npc AS UByte, name AS String, x AS UByte, y AS UByte)
    DIM n, c AS UByte
    
    c = NPC_Color(npc)
    
    PrintFont88(x,y,"eccccccccccccccccccccccccc",c,0)
    PrintFont88(x+10,y,name,c,0)
    
    FOR n = y+8 TO LCARS_Y2 STEP 8
        PrintFont88(x,n, "c                         ",c,0)
    NEXT n
    
    LCARS_ShowImage(x+8,y+8,BANK_BITMAPS1,NPC_Address(npc))

END SUB

