@echo off
cls

echo Compiling!
echo Cleaning files...
del *.nex /Q >nul
rem del *.bin /Q >nul
del nextdrive\*.nex /Q >nul
rem del nextdrive\data\*.bin /Q >nul


call :Main
call :Game
call :Intro
call :Status
call :Help
call :Map
call :Damage
call :Nav
call :Report
call :Combat
goto BUILDNEX


:Main
echo.
echo Compiling: Main
echo ---------------  
c:\zxbasic\zxbc.exe Main.bas -W160 -W140 -W150 -W170 -W190 -S $6000 -O 4 -H 1024 -o Main.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
exit /b


:Game
echo.
echo Compiling: Game (0)
echo -------------------
c:\zxbasic\zxbc.exe Game.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 2048 -o mod-0.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-0.bin nextdrive\data\mod-0.bin
exit /b


:Intro
echo.
echo Compiling: Intro (1)
echo --------------------
c:\zxbasic\zxbc.exe Intro.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 2048 -o mod-1.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-1.bin nextdrive\data\mod-1.bin
exit /b


:Status
echo.
echo Compiling: Status (2)
echo ---------------------
c:\zxbasic\zxbc.exe Status.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 2048 -o mod-2.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-2.bin nextdrive\data\mod-2.bin
exit /b


:Help
echo.
echo Compiling: Help (3)
echo -------------------
c:\zxbasic\zxbc.exe Help.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 2048 -o mod-3.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-3.bin nextdrive\data\mod-3.bin
exit /b


:Map
echo.
echo Compiling: Map (4)
echo ------------------
c:\zxbasic\zxbc.exe Map.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 2048 -o mod-4.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-4.bin nextdrive\data\mod-4.bin
exit /b


:Damage
echo.
echo Compiling: Damage (5)
echo ---------------------
c:\zxbasic\zxbc.exe Damage.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 2048 -o mod-5.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-5.bin nextdrive\data\mod-5.bin
exit /b


:Nav
echo.
echo Compiling: Nav (6)
echo ------------------
c:\zxbasic\zxbc.exe Nav.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 1024 -o mod-6.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-6.bin nextdrive\data\mod-6.bin
exit /b


:Report
echo.
echo Compiling: Report (7)
echo ---------------------
c:\zxbasic\zxbc.exe Report.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 2048 -o mod-7.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-7.bin nextdrive\data\mod-7.bin
exit /b


:Combat
echo.
echo Compiling: Combat (8)
echo ---------------------
c:\zxbasic\zxbc.exe Combat.bas -W160 -W140 -W150 -W170 -W190 -S $8000 -O 4 -H 2048 -o mod-8.bin --zxnext --arch=zxnext -D __ZX_DISABLE_SCROLL -D __ZX_DISABLE_BOLD -D __ZX_DISABLE_ITALIC
if ERRORLEVEL 1 goto compilerError
copy mod-8.bin nextdrive\data\mod-8.bin
exit /b


:BUILDNEX
echo.
echo Building NEX file...
echo --------------------
c:\zxbasic\python\python.exe c:\zxbasic\tools\nextcreator.py .\scripts\nex.cfg sstng.nex
if ERRORLEVEL 1 goto compilerError
copy sstn.nex nextdrive\sstng.nex
call scripts\run.bat
goto endEnd


:compilerError
echo -----------------------------------------------------------------------
echo - Comiler error!!! ----------------------------------------------------
echo -----------------------------------------------------------------------
goto endEnd


:endNow
echo Compilation complete!

:endEnd
